(in-package "USER")

(defvar *begin*)
(defvar *maxtime*)
(defvar *listfile*)
(defvar *protocol-file*)

(setf *maxtime* 60000)
(setf *listfile* "qbf-comp-list")
(setf *protocol-file* "qbf-results")

(defun recomp ()
  (compile-file "gost.lisp")
  (compile-file "gost-simplify.lisp")
  (compile-file "gost-bench-tancs.lisp")
  (compile-file "gost-trans-tancs.lisp")
  (load "gost-bench-tancs.fasl")
  (load "gost.fasl")
  (load "gost-trans-tancs.fasl"))


(defun tbench ()
  (excl:advise construct-node :before watchdog nil 
	       (when (> (- (get-internal-run-time) *begin*) (* *maxtime*  (/ internal-time-units-per-second 100))) 
					;		 (print "out of time") 
		 (throw 'fail nil)))
  
  (with-open-file (in-stream *listfile* :direction :input)
    (do ((nextline (read-line in-stream nil nil)
		   (read-line in-stream nil nil)))
	((null nextline) nil)
      (let* ((tancs-formula nextline)
	     (gf1-formula (transfile tancs-formula))
	     satisfiable begin end time timeout out-of-mem result)
	
	
	(excl:gc t)			; global gc
	(setf begin (get-internal-run-time))
	(setf *begin* begin)
	
	(handler-case 
	    (setf satisfiable (solve gf1-formula))
	  (storage-condition () (setf out-of-mem t)))
	
	(setf end (get-internal-run-time))
	(setf time (/ (- end begin) (/ internal-time-units-per-second 100)))
	
	(if (> time *maxtime*)
	    (setf timeout t)
	  (setf timeout nil))
	
	(setf result 
	  (cond (timeout "T")
		(out-of-mem "M")
		(satisfiable "S")
		(t "U")))
	
	(with-open-file
	    (outstream *protocol-file* 
	     :direction :output
	     :if-exists :append
	     :if-does-not-exist :create)
	  (format outstream "i ~a ~a ~a~%" tancs-formula time result))))))
