(in-package "USER")

(defvar *next-var*)

(defvar *formula*)

(defvar *hypothesis*)

(defun reset ()
  (setf *formula* nil)
  (setf *next-var* 0))

(defun get-next-var ()
  (list '? (incf *next-var*)))
    

(defun transfile (in-file)
  (reset)
  (let ((first-var (get-next-var)))
    (with-open-file (in-stream in-file :direction :input)
      (do ((nextline (read-line in-stream nil nil)
		     (read-line in-stream nil nil)))
	  ((null nextline) nil)
	(with-input-from-string (input nextline)
	  (let ((next-object (read input nil nil)))
	    (unless (or (null next-object) (eq '% next-object))
	      ;; skip empty lines and comment
	      (case next-object
		('hypo (setf *hypothesis* t))
		('conj (setf *hypothesis* nil))
		(otherwise
		 (if *hypothesis*
		     (setf *formula* (cons (trans next-object first-var) *formula*))
		   (setf *formula* (cons (list ':not (trans next-object first-var)) *formula*)))))))))))
    (cons ':and *formula*))
	  
(defun trans (form var)
  (if (listp form)
      (case (first form)
	('box
	 (let ((new-var (get-next-var)))
	   (case (second form)
	     ('r1
	      (list ':all (list new-var) (list 'r var new-var) (trans (third form) new-var)))
	     ('r1-
	      (list ':all (list new-var) (list 'r new-var var) (trans (third form) new-var)))
	     (otherwise
	      (transerror form)))))
	('pos
	 (let ((new-var (get-next-var)))
	   (case (second form)
	     ('r1
	      (list ':ex (list new-var) (list 'r var new-var) (trans (third form) new-var)))
	     ('r1-
	      (list ':ex (list new-var) (list 'r new-var var) (trans (third form) new-var)))
	     (otherwise
	      (transerror form)))))
	('~
	 (list ':not (trans (second form) var)))
	
	(otherwise
	 (case (second form)
	   ('&
	    (list ':and (trans (first form) var) (trans (rest (rest form)) var)))
	   ('+
	    (list ':or (trans (first form) var) (trans (rest (rest form)) var)))
	   (otherwise
	    (if (rest form)
		(transerror form)
	      ;; if form contains only one element, translate it
	      (trans (first form) var))))))
    ;; not listp
    (case form
      ('true '(:TOP))
      ('false '(:BOTTOM))
      (nil
       (transerror form))
      (otherwise
       (list form var)))))


(defun transerror (term)
  (format t "trans error: ~s~%" term))

